#include <iostream>
#include <vector>

using namespace std;

const long long INF = 1000000000000000000LL;
vector<bool> used;
vector<vector<int>> gr;
vector<int> a;
int n, k;
vector<int> prv;
int sel, paths;

pair<long long, int> dfs(int u, int p, long long cd) {
    cd += a[u];
    pair<long long, int> mx = {cd, u};
    for (int v : gr[u]) {
        if (v != p && !used[v]) {
            mx = max(mx, dfs(v, u, cd));
        }
    }
    return mx;
}

void dfs1(int u, int p) {
    prv[u] = p;
    for (int v : gr[u]) {
        if (v != p && !used[v]) {
            dfs1(v, u);
        }
    }
}

void max_path() {
    long long bd = -INF;
    int u = -1, v = -1;
    for (int i = 0; i < n; i++) {
        if (used[i]) continue;
        auto p = dfs(i, -1, 0);
        if (p.first > bd) {
            bd = p.first;
            u = i;
            v = p.second;
        }
    }

    if (bd < 0) {
        if (sel > paths) {
            paths++;
            return;
        }
    }

    prv.assign(n, -1);
    dfs1(u, -1);

    int cv = v;
    while (cv != -1) {
        used[cv] = true;
        sel++;
        cv = prv[cv];
    }

    paths++;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    used.resize(n);

    for (int i = 0; i < k; i++) {
        max_path();
    }

    long long s = 0;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            s += a[i];
        }
    }

    cout << s << endl;

    return 0;
}