#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long INF = 1000000000000000000LL;
int n, k;
vector<int> a;
vector<vector<int>> gr;
vector<vector<long long>> dp[2];

void dfs(int u, int p) {
    vector<vector<long long>> cdp0(1, vector<long long>(2 * k + 1, -INF)); // not used
    vector<vector<long long>> cdp1(1, vector<long long>(2 * k + 1, -INF)); // used in vertical path
    vector<vector<long long>> cdp2(1, vector<long long>(2 * k + 1, -INF)); // used in non-vertical path
    cdp0[0][0] = 0;
    int l = 0;

    for (int v : gr[u]) {
        if (v == p) continue;

        dfs(v, u);

        cdp0.push_back(vector<long long>(2 * k + 1, -INF));
        cdp1.push_back(vector<long long>(2 * k + 1, -INF));
        cdp2.push_back(vector<long long>(2 * k + 1, -INF));
        l++;

        for (int i = 0; i <= k; i++) {
            for (int j = 0; j <= k; j++) {
                // 0 + 0
                if (i + j <= k && cdp0[l - 1][i] != -INF && dp[0][v][j] != -INF) {
                    cdp0[l][i + j] = max(cdp0[l][i + j], cdp0[l - 1][i] + dp[0][v][j]);
                }

                // 0 + 1, don't add u
                if (i + j + 1 <= k && cdp0[l - 1][i] != -INF && dp[1][v][j] != -INF) {
                    cdp0[l][i + j + 1] = max(cdp0[l][i + j + 1], cdp0[l - 1][i] + dp[1][v][j]);
                }

                // 0 + 1, add u
                if (i + j <= k && cdp0[l - 1][i] != -INF && dp[1][v][j] != -INF) {
                    cdp1[l][i + j] = max(cdp1[l][i + j], cdp0[l - 1][i] + dp[1][v][j] + a[u]);
                }

                // 1 + 0
                if (i + j <= k && cdp1[l - 1][i] != -INF && dp[0][v][j] != -INF) {
                    cdp1[l][i + j] = max(cdp1[l][i + j], cdp1[l - 1][i] + dp[0][v][j]);
                }

                // 1 + 1, don't merge
                if (i + j + 1 <= k && cdp1[l - 1][i] != -INF && dp[1][v][j] != -INF) {
                    cdp1[l][i + j + 1] = max(cdp1[l][i + j + 1], cdp1[l - 1][i] + dp[1][v][j]);
                }

                // 1 + 1, merge
                if (i + j + 1 <= k && cdp1[l - 1][i] != -INF && dp[1][v][j] != -INF) {
                    cdp2[l][i + j + 1] = max(cdp2[l][i + j + 1], cdp1[l - 1][i] + dp[1][v][j]);
                }

                // 2 + 0
                if (i + j <= k && cdp2[l - 1][i] != -INF && dp[0][v][j] != -INF) {
                    cdp2[l][i + j] = max(cdp2[l][i + j], cdp2[l - 1][i] + dp[0][v][j]);
                }

                // 2 + 1
                if (i + j + 1 <= k && cdp2[l - 1][i] != -INF && dp[1][v][j] != -INF) {
                    cdp2[l][i + j + 1] = max(cdp2[l][i + j + 1], cdp2[l - 1][i] + dp[1][v][j]);
                }
            }
        }
    }

    for (int i = 0; i <= k; i++) {
        cdp1[l][i] = max(cdp1[l][i], cdp0[l][i] + a[u]);
    }

    for (int i = 0; i <= k; i++) {
        dp[0][u][i] = max(cdp0[l][i], cdp2[l][i]);
    }
    dp[1][u] = cdp1.back();
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> k;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    gr.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    for (int j = 0; j < 2; j++) {
        dp[j].resize(n);
        for (int i = 0; i < n; i++) {
            dp[j][i].assign(2 * k + 1, -INF);
        }
    }

    dfs(0, -1);

    cout << max(dp[0][0][k], dp[1][0][k - 1]) << endl;

    return 0;
}
